// 002 u_volume
// 14 oct 2007

// -- (C) Felix John COLIBRI 2007
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_volume;
  interface
    uses Windows, u_c_basic_object;


    function f_wave_volume: DWord;
    procedure set_wave_volume(const AVolume: DWord);

  implementation
    uses SysUtils, mmsystem
        , u_c_display
        ;

    function f_wave_volume: DWord;
      var l_wave_out_capabilities : TWAVEOUTCAPS;
      begin
        if WaveOutGetDevCaps(WAVE_MAPPER, @l_wave_out_capabilities,
            sizeof(l_wave_out_capabilities)) = MMSYSERR_NOERROR
          then begin
              if l_wave_out_capabilities.dwSupport
                  and WAVECAPS_VOLUME = WAVECAPS_VOLUME
                then begin
                    WaveOutGetVolume(WAVE_MAPPER, @ Result);
                  end
                else display_bug_stop('no_volume_support')  ;
            end
          else display_bug_stop('mmsyserr_noerror');
      end; // f_wave_volume

    procedure set_wave_volume(const AVolume: DWord);
      var l_wave_out_capabilities : TWAVEOUTCAPS;
      begin
        if WaveOutGetDevCaps(WAVE_MAPPER, @l_wave_out_capabilities,
            sizeof(l_wave_out_capabilities)) = MMSYSERR_NOERROR
          then
            if l_wave_out_capabilities.dwSupport and WAVECAPS_VOLUME = WAVECAPS_VOLUME
              then WaveOutSetVolume(WAVE_MAPPER, AVolume);
      end; // set_wave_volume

    begin // u_zzz
    end. // u_zzz
