// 003 u_delphi_3d_designer
// 29 may 2005

// -- (C) Felix John COLIBRI 2007
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_flash_player;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, ShockwaveFlashObjects_TLB, ExtCtrls,
  ComCtrls, Buttons, FileCtrl;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Panel1: TPanel;
    Panel2: TPanel;
    PageControl1: TPageControl;
    dir_: TTabSheet;
    play_: TTabSheet;
    stop_panel_: TPanel;
    resize_: TButton;
    frame_edit_: TEdit;
    set_frame_edit_: TEdit;
    set_frame_: TButton;
    pause_: TButton;
    Panel4: TPanel;
    backword_button_: TSpeedButton;
    back_button_: TSpeedButton;
    position_trackbar_: TTrackBar;
    step_edit_: TEdit;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    exit_: TButton;
    clear_: TButton;
    log_: TTabSheet;
    Memo1: TMemo;
    sw_panel_: TPanel;
    Splitter1: TSplitter;
    ShockwaveFlash1: TShockwaveFlash;
    Panel3: TPanel;
    real_size_: TRadioButton;
    stretch_: TRadioButton;
    vol_: TTabSheet;
    beep_: TButton;
    display_volume_: TButton;
    volume_: TButton;
    set_volume_edit_: TEdit;
    volume_min_: TButton;
    volume_max_: TButton;
    get_volume_edit_: TEdit;
    load_: TButton;
    max_: TButton;
    save_frame_: TButton;
    volume_trackbar_: TTrackBar;
    snapshot_name_edit_: TEdit;
    snapshot_button_: TButton;
    total_frame_label_: TLabel;
    Panel5: TPanel;
    url_edit_: TEdit;
    size_label_: TLabel;
    set_sizes_: TButton;
    procedure pause_Click(Sender: TObject);
    procedure resize_Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure set_frame_Click(Sender: TObject);
    procedure load_Click(Sender: TObject);
    procedure position_trackbar_Change(Sender: TObject);
    procedure backword_button_Click(Sender: TObject);
    procedure back_button_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure real_size_Click(Sender: TObject);
    procedure beep_Click(Sender: TObject);
    procedure display_volume_Click(Sender: TObject);
    procedure volume_Click(Sender: TObject);
    procedure volume_min_Click(Sender: TObject);
    procedure volume_max_Click(Sender: TObject);
    procedure start_position_button_Click(Sender: TObject);
    procedure max_Click(Sender: TObject);
    procedure save_frame_Click(Sender: TObject);
    procedure volume_trackbar_Change(Sender: TObject);
    procedure snapshot_button_Click(Sender: TObject);
    procedure ShockwaveFlash1ReadyStateChange(Sender: TObject;
      newState: Integer);
    procedure snapshot_name_edit_Change(Sender: TObject);
    procedure snapshot_name_edit_KeyPress(Sender: TObject; var Key: Char);
    procedure pause_KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure set_sizes_Click(Sender: TObject);
  private
    procedure initialize_volume_trackbar;
  public
  end;

var
  Form1: TForm1;

implementation
  uses ClipBrd
      , u_types_constants, u_characters, u_c_log, u_c_display, u_display_hex_2
      , u_file, u_dir
      , u_c_ini_file
      , u_strings
      , u_volume
      ;


    {$R *.dfm}

    const k_initial_directory= 'C:\prog\graph\multi_media\_swf\';
            k_extension= '.pas';
            k_file_name= 'xxx.swf';
            k_initial_frame_number= '0';

          k_xxx_path_ini_key=   'ini_xxx_path';
          k_xxx_file_name_ini_key=   'ini_xxx_file_name';
          // -- todo
          k_xxx_frame_number_ini_key= 'ini_frame_number';


    var g_path: String= k_initial_directory;
        g_file_name: String= k_file_name;

        g_c_ini_file: c_ini_file= Nil;

        g_file_count: Integer= 0;
        g_save_frame: Integer= -1;

        g_use_changing_trackbar: Boolean= False;
        g_do_pause_: Boolean= False;

        g_ready_state: Integer= 0;

    procedure display_path_and_file;
      begin
        Form1.Caption:= g_path+ g_file_name;
      end; // display_path_and_file

    procedure my_call_back(p_level: Integer; p_path, p_file_name: String;
        p_pt_data: Pointer);
      begin
        g_path:= p_path; g_file_name:= p_file_name;
        display_path_and_file;

        Inc(g_file_count);

        Form1.PageControl1.ActivePage:= Form1.play_;
      end; // my_call_back

    procedure set_panel_color(p_color: Integer);
      begin
        Form1.stop_panel_.Color:= p_color;
        Application.ProcessMessages;
      end; // set_panel_color

    function f_load_directory_frame_number(var pv_save_frame_number: Integer): Boolean;
      var l_frame_number_string: String;
          // l_frame_number: Integer;
      begin
        Result:= False;
        pv_save_frame_number:= -1;

        if FileExists(g_path+ 'save_frame_number.txt')
          then begin
              // -- todo
              with tStringList.Create do
              begin
                LoadFromFile('save_frame_number.txt');
                l_frame_number_string:= Strings[0];
                u_c_display.display(Text);
                Result:= True;
                pv_save_frame_number:= StrToInt(Strings[0]);

                Free;
              end;
            end;
      end; // load_directory_frame_number

    procedure TForm1.FormCreate(Sender: TObject);
      var l_initial_frame_number: Integer;
          l_save_frame_number: Integer;
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        g_c_ini_file:= c_ini_file.create_ini_file('');
        with g_c_ini_file do
        begin
          // -- whatever is in "fig_ini.txt"
          load_from_default_file;

          // -- initialize the variables with INI or, if none, with constants
          g_path:= f_initialize_parameter(k_xxx_path_ini_key, k_initial_directory);
          g_file_name:= f_initialize_parameter(k_xxx_file_name_ini_key, k_file_name);
          l_initial_frame_number:= StrToInt(f_initialize_parameter(k_xxx_frame_number_ini_key, k_initial_frame_number));
          if l_initial_frame_number<> 0
            then begin
                set_frame_edit_.Text:= IntToStr(l_initial_frame_number);
              end;
        end; // with g_c_ini_file

        display_path_and_file;

        set_directory_listbox_directory(DirectoryListBox1, g_path);
        with FileListBox1 do
          ItemIndex:= Items.IndexOf(g_file_name);

        if f_load_directory_frame_number(l_save_frame_number)
          then set_frame_edit_.Text:= IntToStr(l_save_frame_number);

        initialize_volume_trackbar;
        g_do_pause_:= True;
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.DirectoryListBox1Change(Sender: TObject);
      begin
        with DirectoryListBox1 do
          g_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_xxx_path_ini_key, g_path);
      end; // DirectoryListBox1Change

    // -- call handler

    procedure TForm1.FileListBox1Click(Sender: TObject);
        // -- the file clicked in the bottom list_box
      begin
        with FileListbox1 do
          g_file_name:= Items[ItemIndex];

        g_c_ini_file.set_parameter(k_xxx_file_name_ini_key, g_file_name);

        g_file_count:= 0;
        my_call_back(0, g_path, g_file_name, Nil);
      end; // FileListBox1Click

    procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
      begin
        // -- grab the last current frame
        if g_save_frame<> -1
          then begin
              g_c_ini_file.set_parameter(k_xxx_frame_number_ini_key,
                IntToStr(g_save_frame));
              // -- save to local file
              with tStringList.Create do
              begin
                display('save_to '+ g_path+ 'save_frame_number.txt');
                Add(IntToStr(g_save_frame));
                SaveToFile(g_path+ 'save_frame_number.txt');
                Free;
              end;
            end;
        g_c_ini_file.save_to_default_file;
      end; // FormClose

    // -- events

    procedure TForm1.load_Click(Sender: TObject);
      begin // load_Click
        set_panel_color(clRed);
        ShockwaveFlash1.Free;

        ShockwaveFlash1:= TShockwaveFlash.Create(nil);
        with ShockwaveFlash1 do
        begin
          Parent:= sw_panel_;
          Align:= alClient;
          Loop:= true;

          Scale:= 'exactFit';
          Form1.stretch_.Checked:= True;
          // Scale:= 'ExtractFit';
          // Scale:= 'NoBorder';  this somehow works
          // Scale:= 'ExactFit';  // this somehow works

          Menu:= false;

          BackgroundColor:= -1;
          SetFocus;
          // -- readjust
          Realign;

          if url_edit_.Text<> ''
            then begin
                g_ready_state:= 0;
                Movie:= url_edit_.Text;
                repeat
                  Application.ProcessMessages;
                until g_ready_state>= 2;
              end
            else Movie:= g_path+ g_file_name;


          position_trackbar_.Max:= TotalFrames;

          total_frame_label_.Caption:= IntToStr(TotalFrames);
          g_use_changing_trackbar:= False;

          Timer1.Enabled:= True;
        end; // with ShockwaveFlash1
        set_panel_color(clLime);
      end; // load_Click

    procedure TForm1.pause_Click(Sender: TObject);
      begin
        ShockwaveFlash1.Playing:= Not ShockwaveFlash1.Playing;

        if ShockwaveFlash1.Playing
          then set_panel_color(clLime)
          else set_panel_color(clRed);
      end; // pause_Click

    procedure TForm1.resize_Click(Sender: TObject);
      var l_save_frame_number: Integer;
          l_save_scale: WideString;
      begin
        set_panel_color(clRed);

        // -- remember the value before resizing
        l_save_frame_number:= ShockwaveFlash1.FrameNum;
        l_save_scale:= ShockwaveFlash1.Scale;

        load_click(Nil);

        ShockwaveFlash1.FrameNum:= l_save_frame_number;
        pause_Click(Nil);
        ShockwaveFlash1.Scale:= l_save_scale;

        set_panel_color(clLime);

        pause_.SetFocus;
      end; // resize_start_Click

    procedure TForm1.Timer1Timer(Sender: TObject);
      begin
        with ShockwaveFlash1 do
        begin
          g_use_changing_trackbar:= False;
          display('tick '+ f_display_TF(g_use_changing_trackbar));

          frame_edit_.Text:= IntToStr(FrameNum);

          position_trackbar_.Position:= FrameNum;
        end; // with ShockwaveFlash1
      end; // Timer1Timer

    procedure TForm1.set_frame_Click(Sender: TObject);
      var l_target_frame: Integer;
      begin
        l_target_frame:= StrToInt(set_frame_edit_.Text);
        with ShockwaveFlash1 do
        begin
          FrameNum:= l_target_frame;
          // -- when sets the frame number, ??
          pause_.SetFocus;
          pause_Click(Nil);
        end;
        g_save_frame:= l_target_frame;
      end; // set_frame_Click

    var g_track_change_count: Integer= 0;

    procedure TForm1.position_trackbar_Change(Sender: TObject);
      var l_save_scale: WideString;
      begin
        display(IntToStr(g_track_change_count)+ ' track_change ');
        Inc(g_track_change_count);

        if not g_use_changing_trackbar
          then begin
              g_use_changing_trackbar:= True;
              Exit;
            end;
        display('  ok');
        l_save_scale:= ShockwaveFlash1.Scale;

        ShockwaveFlash1.FrameNum:= position_trackbar_.Position;
        pause_Click(Nil);
        ShockwaveFlash1.Scale:= l_save_scale;
        pause_.SetFocus;
      end; // TrackBar1Change

    procedure TForm1.backword_button_Click(Sender: TObject);
      begin
        with ShockwaveFlash1 do
          FrameNum:= FrameNum- StrToInt(step_edit_.Text);
        pause_Click(Nil);
        pause_.SetFocus;
      end; // backword_button_Click

    procedure TForm1.start_position_button_Click(Sender: TObject);
      begin
        with ShockwaveFlash1 do
          FrameNum:= FrameNum+ StrToInt(step_edit_.Text);
        pause_Click(Nil);
        pause_.SetFocus;
      end; // start_position_button_Click

    procedure TForm1.back_button_Click(Sender: TObject);
      begin
        with ShockwaveFlash1 do
          FrameNum:= FrameNum+ StrToInt(step_edit_.Text);
        pause_Click(Nil);
        pause_.SetFocus;
      end; // back_button_Click

    procedure TForm1.real_size_Click(Sender: TObject);
      begin
        with ShockwaveFlash1 do
          if Sender= real_size_
            then Scale:= 'ShowAll' else
          if Sender= stretch_
            then Scale:= 'ExactFit' else;
        pause_.SetFocus;
      end; // real_size_Click

    // -- volume
      
    procedure TForm1.volume_Click(Sender: TObject);
      var l_low_volume: Word;
          l_high_volume: Word;
      begin
        l_low_volume:= StrToInt(set_volume_edit_.Text);
        l_high_volume:= StrToInt(set_volume_edit_.Text);

        set_wave_volume(MakeLong(l_low_volume, l_high_volume));
      end; // volume_Click

    procedure TForm1.beep_Click(Sender: TObject);
      begin
        Beep;
      end; // beep_Click

    procedure TForm1.display_volume_Click(Sender: TObject);
      begin
        get_volume_edit_.Text:= f_integer_to_hex(Integer(f_wave_volume));
      end; // display_volume_Click

    procedure TForm1.volume_min_Click(Sender: TObject);
      begin
        set_wave_volume(MakeLong(0, 0));
      end; // volume_min_Click

    procedure TForm1.volume_max_Click(Sender: TObject);
      begin
        (*$r-*)
        set_wave_volume(MakeLong(Word($FFFF), Word($FFFF)));
        (*$r+*)
      end; // volume_max_Click

    procedure TForm1.initialize_volume_trackbar;
      begin
        volume_trackbar_.Position:= Loword(f_wave_volume) div 256;
      end; // initialize_volume_trackbar

    procedure TForm1.volume_trackbar_Change(Sender: TObject);
      var l_volume: Integer;
      begin
        l_volume:= volume_trackbar_.Position;
        l_volume:= 256* l_volume;
        (*$r-*)
        set_wave_volume(MakeLong(Word(l_volume), Word(l_volume)));
        (*$r+*)
        if g_do_pause_
          then pause_.SetFocus;
      end; // volume_trackbar_Change

    // -- resize window to max

    procedure TForm1.max_Click(Sender: TObject);
      begin
        WindowState:= wsMaximized;
        Panel1.Width:= 90;
        resize_Click(Nil);
        real_size_.Checked:= True;
        real_size_Click(Nil);
      end; // max_Click

    procedure TForm1.save_frame_Click(Sender: TObject);
      begin
        g_save_frame:= StrToInt(frame_edit_.Text);
        set_frame_edit_.Text:= frame_edit_.Text;

        g_c_ini_file.set_parameter(k_xxx_frame_number_ini_key,
            IntToStr(g_save_frame));
        // -- save to local file
        with tStringList.Create do
        begin
          display('save_to '+ g_path+ 'save_frame_number.txt');
          Add(IntToStr(g_save_frame));
          SaveToFile(g_path+ 'save_frame_number.txt');
          Free;
        end;
        g_c_ini_file.save_to_default_file;

        pause_.SetFocus;
      end; // save_frame_Click

    function f_snapshot_number: String;
        // -- compute 000frame_number '_' snapshot_name_edit
      var l_index: Integer;
      begin
        with Form1 do
        begin
          Result:= frame_edit_.Text;
          l_index:= Length(Result);
          while l_index< 5 do
          begin
            Result:= '0'+ Result;
            Inc(l_index);
          end; // while l_index
        end; // with Form1
      end; // f_snapshot_number

    procedure TForm1.snapshot_button_Click(Sender: TObject);

      procedure save_from_screen_dc;
        var l_screen_rectangle: TRect;
            l_width, l_height: Integer;
            l_bitmap_rectangle: TRect;
            l_desktop_dc: HDC;
            l_c_desktop_canvas: TCanvas;
            l_c_bitmap: tBitmap;
            l_save_path, l_save_name: String;
        begin
          // -- x1, y1
          l_screen_rectangle:= Rect(Panel1.Width- 5, 10, Panel1.Width+ sw_panel_.Width+ 20, 10+ sw_panel_.Height+ 20);
          l_width:= l_screen_rectangle.Right - l_screen_rectangle.Left;
          l_height:= l_screen_rectangle.Bottom - l_screen_rectangle.Top;

          l_c_bitmap:= tBitmap.Create;

          l_bitmap_rectangle:= Rect(0, 0, l_width, l_height);
          l_c_bitmap.PixelFormat:= pf24bit;  // optional
          l_c_bitmap.Width:= l_width;
          l_c_bitmap.Height:= l_height;

          l_desktop_dc:= GetWindowDC(GetDeskTopWindow);
          try
            l_c_desktop_canvas:= TCanvas.Create;
            try
              l_c_desktop_canvas.Handle:= l_desktop_dc;
              l_c_bitmap.Canvas.CopyMode:= cmSrcCopy;
              l_c_bitmap.Canvas.CopyRect(l_bitmap_rectangle, l_c_desktop_canvas, l_screen_rectangle);

              l_save_path:= g_path+ '_i_image\';
              f_create_path(l_save_path);

              l_save_name:= l_save_path+ 'fig_'+ f_snapshot_number+ '_'+ snapshot_name_edit_.Text+ '.png';
              display('save '+ l_save_name);

              // -- now convert to .PNG and save
              // WriteBitmapToPngFile(l_save_name, l_c_bitmap, clNone);
              l_c_bitmap.SaveToFile(l_save_name);
              display('  ok');

              l_c_bitmap.Free;

              // -- add for .Ed
              ClipBoard.AsText:= 'fig_'+ snapshot_name_edit_.Text;
            finally
              l_c_desktop_canvas.Free;
            end;
          finally
            ReleaseDC(GetDeskTopWindow, l_desktop_dc);
          end;

          pause_.SetFocus;
        end; // save_from_screen_dc

      begin // snapshot_button_Click
        save_from_screen_dc;
      end; // snapshot_button_Click

    procedure TForm1.snapshot_name_edit_Change(Sender: TObject);
        // -- typed in the snapshot edit, pause, and when hits return enters this .PNG
      begin
        if ShockwaveFlash1.Playing
          then ShockwaveFlash1.Playing:= False;

        set_panel_color(clRed);
      end; // snapshot_name_edit_Change

    procedure TForm1.pause_KeyDown(Sender: TObject; var Key: Word;
        Shift: TShiftState);
      // -- jump to the snapshot_name_edit => pause and ready to entre the name
      var l_snapshot_name_edit: String;
      begin
        if (key= vk_shift) // or (key= vk_Return)
          then begin
              // -- force a change to trigger a stop
              l_snapshot_name_edit:= snapshot_name_edit_.Text;
              snapshot_name_edit_.Text:= l_snapshot_name_edit+ ' ';
              snapshot_name_edit_.Text:= l_snapshot_name_edit;
              snapshot_name_edit_.SetFocus;

              Key:= 0;
            end;
      end; // pause_KeyDown

    procedure TForm1.snapshot_name_edit_KeyPress(Sender: TObject;
        var Key: Char);
      begin
        if (Key= k_return)
          then begin
              // -- save on disc
              snapshot_button_Click(Nil);

              // -- now get the focus back to pause
              pause_.SetFocus;
              // -- and restart
              if Not ShockwaveFlash1.Playing
                then ShockwaveFlash1.Playing:= True;

              set_panel_color(clLime);
            end;
      end; // snapshot_name_edit_KeyPress

    procedure TForm1.ShockwaveFlash1ReadyStateChange(Sender: TObject;
        newState: Integer);
        // -- try to use html download
      begin
        g_ready_state:= NewState;
      end; // ShockwaveFlash1ReadyStateChange

    // -- for flash builder adjustments

    procedure TForm1.FormResize(Sender: TObject);
      begin
        size_label_.Caption:= Format('w =%6d  h =%6d', [Width, Height]);
        Caption:= Format('w =%6d  h =%6d', [Width, Height]);
      end; // FormResize

    procedure TForm1.set_sizes_Click(Sender: TObject);
      begin
        Left:= 25;
        Top:= 55;
        Width:= 400;
        Height:= 580;
      end;

end.


